<?php

namespace Drupal\config_sync;

/**
 * The ConfigSyncSnapshotter provides helper functions for taking snapshots of
 * extension-provided configuration.
 */
interface ConfigSyncSnapshotterInterface {

  /**
   * Install snapshot mode.
   */
  const SNAPSHOT_MODE_INSTALL = 'install';

  /**
   * Import snapshot mode.
   */
  const SNAPSHOT_MODE_IMPORT = 'import';

  /**
   * Takes a snapshot of configuration from specified modules or themes.
   *
   * Only new or changed items are added.
   *
   * @param string $type
   *   The type of extension to snapshot.
   * @param array $names
   *   An array of extension names.
   * @param string $mode
   *   The snapshot mode. Valid values are:
   *   - \Drupal\config_sync\ConfigSyncSnapshotterInterface::SNAPSHOT_MODE_INSTALL
   *   - \Drupal\config_sync\ConfigSyncSnapshotterInterface::SNAPSHOT_MODE_IMPORT
   */
  public function refreshExtensionSnapshot($type, array $names, $mode);

  /**
   * Takes a snapshot of configuration from all installed modules and themes.
   */
  public function createSnapshot();

}
