<?php

namespace Drupal\config_sync\Plugin;

use Drupal\config_provider\Plugin\ConfigCollector;

/**
 * Class for invoking configuration providers.
 */
class SyncConfigCollector extends ConfigCollector implements SyncConfigCollectorInterface {

  /**
   * {@inheritdoc}
   */
  public function addConfigForSnapshotting(array $extensions = []) {
    /* @var \Drupal\config_provider\Plugin\ConfigProviderInterface[] $providers */
    $providers = $this->getConfigProviders();

    foreach ($providers as $provider) {
      if (!$provider instanceof SyncConfigProviderInterface) {
        $provider->addInstallableConfig($extensions);
      }
    }
  }

  /**
   * {@inheritdoc}
   */
  public function alterConfigForSnapshotting(array $extensions = []) {
    /* @var \Drupal\config_provider\Plugin\ConfigProviderInterface[] $providers */
    $providers = $this->getConfigProviders();

    foreach ($providers as $provider) {
      if ($provider instanceof SyncConfigProviderInterface) {
        $provider->alterConfigForSnapshotting($extensions);
      }
    }
  }

}
