<?php

namespace Drupal\config_sync\Plugin;

use Drupal\config_provider\InMemoryStorage;
use Drupal\config_provider\Plugin\ConfigProviderInterface;

/**
 * Class for invoking configuration providers for snapshotting.
 */
interface SyncConfigProviderInterface extends ConfigProviderInterface {

  /**
   * Alters configuration to be used for snapshotting.
   *
   * Not intended to be called an install time, this method instead facilitates
   * determining what configuration updates are available.
   *
   * Implementing plugins should write configuration as appropriate to the
   * ::providerStorage storage.
   *
   * @param \Drupal\Core\Extension\Extension[] $extensions
   *   (Optional) An associative array of Extension objects, keyed by extension
   *   name. If provided, data loaded will be limited to these extensions.
   *
   * @see \Drupal\config_provider\Plugin\ConfigProviderInterface\addInstallableConfig()
   */
  public function alterConfigForSnapshotting(array $extensions = []);

}
